// tccrypt.cpp : Defines the entry point for the application.
//

#if defined(__cplusplus)
extern "C"
{
#endif

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include "resource.h"
#include "passcrypt.h"
#include "zlib.h"
#include "utils.h"
#include "cvtutf.h"

// Link with the Advapi32.lib file.
#pragma comment (lib, "advapi32")

// Global constants
#define MAX_LOADSTRING 100
// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text
HWND hWndMain;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void DecryptFunction(HWND);
void ReEncryptFunction(HWND);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TCCRYPT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!IsDialogMessage(hWndMain, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_TCCRYPT);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_TCCRYPT;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateDialog(hInstance,MAKEINTRESOURCE(IDD_MAINDIALOG),0,(DLGPROC)WndProc);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   hWndMain=hWnd;

   return TRUE;
}

void BrowseForIniFile(HWND hWnd)
{
	OPENFILENAME  ofn;
    char szFileName[MAX_PATH] ;
    strcpy(szFileName, TEXT("*.ini")) ;
    
    ZeroMemory(&ofn, sizeof(OPENFILENAME)) ;
    ofn.lStructSize = sizeof(OPENFILENAME) ;
    ofn.hwndOwner = hWnd ;
    ofn.lpstrFilter = "INI Files\0*.ini\0All Files\0*.*\0";
    ofn.nFilterIndex = 1;
    ofn.lpstrFile = szFileName ;
    ofn.nMaxFile = sizeof(szFileName) ;
    ofn.lpstrFileTitle = NULL ;
    ofn.lpstrTitle = TEXT("Open wcx_ftp.ini file");
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL ;
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
    if (GetOpenFileName(&ofn)) // user specified a file
    {      
        SetDlgItemText(hWnd,IDC_ININAME,szFileName);
    }
}

void FillCombobox(HWND hWnd)
{
	char connlist[32768],ftpininame[MAX_PATH],passmime[MAX_PATH],*p;
	SendDlgItemMessage(hWnd,IDC_CONNECTION,CB_RESETCONTENT,0,0);
	GetDlgItemText(hWnd,IDC_ININAME,ftpininame,sizeof(ftpininame)-1);
	connlist[0]=0;
	GetPrivateProfileString(NULL,NULL,NULL,connlist,sizeof(connlist)-1,ftpininame);
	strcpy(passmime,"* (export all)");
	p=passmime;
	SendDlgItemMessage(hWnd,IDC_CONNECTION,CB_ADDSTRING,0,(LPARAM)p);

	p=connlist;
	while (p[0]) {
		passmime[0]=0;
		GetPrivateProfileString(p,"password","",passmime,sizeof(passmime)-1,ftpininame);
		if (passmime[0]=='!' && passmime[1]=='2')
			SendDlgItemMessage(hWnd,IDC_CONNECTION,CB_ADDSTRING,0,(LPARAM)p);
		p+=strlen(p)+1;
	}
}

void TryLocateFtpIni(HWND hWnd)
{
	char inifile[MAX_PATH+1],testbuf[MAX_PATH+1];
	if (GetEnvironmentVariable("commander_ini",inifile,MAX_PATH)>0) {
		char* p=strrchr(inifile,'\\');
		if (p) {
			p[1]=0;
			strncat(inifile,"wcx_ftp.ini",MAX_PATH);
			if (GetPrivateProfileString(NULL,NULL,"",testbuf,sizeof(testbuf)-1,inifile)) {
				SetDlgItemText(hWnd,IDC_ININAME,inifile);
				FillCombobox(hWnd);
			}
		}
	}
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	switch (message) 
	{
		case WM_INITDIALOG:
			TryLocateFtpIni(hWnd);
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDC_BROWSEBTN:
					if (wmEvent==BN_CLICKED)
						BrowseForIniFile(hWnd);
					break;
				case ID_DECRYPT:
				   DecryptFunction(hWnd);
				   break;
				case ID_REENCRYPT:
				   ReEncryptFunction(hWnd);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				case IDC_ININAME:
					if (wmEvent==EN_CHANGE)
						FillCombobox(hWnd);
					break;
				default:
				   return FALSE;
			}
			break;
		case WM_SYSCOMMAND:
			if (wParam==SC_CLOSE)
				DestroyWindow(hWnd);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return FALSE;
   }
   return DefWindowProc(hWnd,message,wParam,lParam);
}

void DecryptFunction(HWND hWnd)
{
	char ftpininame[MAX_PATH],connname[MAX_PATH],masterpass[MAX_PATH],
		 passmime[MAX_PATH],decryptbuf[MAX_PATH],salt[saltsize];
	unsigned char passbuf[MAX_PATH];
	WCHAR masterpassW[MAX_PATH];
	int len;

	GetDlgItemText(hWnd,IDC_ININAME,ftpininame,sizeof(ftpininame)-1);
	GetDlgItemText(hWnd,IDC_CONNECTION,connname,sizeof(connname)-1);
	GetDlgItemText(hWnd,IDC_MASTERPASS,masterpass,sizeof(masterpass)-1);
	// The password is in UTF-8
	MultiByteToWideChar(CP_ACP,0,masterpass,-1,masterpassW,MAX_PATH);
	WCHAR* srcstart=masterpassW;
	unsigned char* trgstart=(unsigned char*)masterpass;
	ConvertUTF16toUTF8(&srcstart,srcstart+wcslen(srcstart)+2,
		&trgstart,trgstart+sizeof(masterpass)-1);

	passmime[0]=0;
	GetPrivateProfileString(NULL,NULL,NULL,passmime,sizeof(passmime)-1,ftpininame);
	if (strlen(passmime)==0) {
		SetDlgItemText(hWnd,IDC_RESULT,"Could not find wcx_ftp.ini file!");
		return;
	}
	
	if (strcmp(connname,"* (export all)")==0) {
		int cnt=SendDlgItemMessage(hWnd,IDC_CONNECTION,CB_GETCOUNT,0,0);
		char* presult=(char*)malloc(cnt*500+100);
		int i=0;
		strcpy(presult,"host\tuser\tpassword\n\n");
		while (i<cnt) {
			SendDlgItemMessage(hWnd,IDC_CONNECTION,CB_GETLBTEXT,i,(LPARAM)&connname);
			passmime[0]=0;
			GetPrivateProfileString(connname,"password",NULL,passmime,sizeof(passmime)-1,ftpininame);
			if (passmime[0]=='!' && passmime[1]=='2') {
				len=MimeDecode(passmime+2,passbuf);
				if (len>saltsize) {
					memcpy(&salt,&passbuf,saltsize);
					memcpy(&decryptbuf,&passbuf[saltsize],len-saltsize);
					int err=DecryptPassword(masterpass,salt,decryptbuf,len-saltsize);
					if (err==0) {
						GetPrivateProfileString(connname,"host",NULL,passmime,sizeof(passmime)-1,ftpininame);
						strlcat(presult,passmime,cnt*500-1);
						strlcat(presult,"\t",cnt*500-1);
						GetPrivateProfileString(connname,"username",NULL,passmime,sizeof(passmime)-1,ftpininame);
						strlcat(presult,passmime,cnt*500-1);
						strlcat(presult,"\t",cnt*500-1);
						strlcat(presult,decryptbuf,cnt*500-1);
						strlcat(presult,"\n",cnt*500-1);
					}
				}
			}
			i++;
		}
		MessageBox(hWnd,presult,"Press Ctrl+C to copy list",MB_OK);
		return;
	}

	passmime[0]=0;
	GetPrivateProfileString(connname,NULL,NULL,passmime,sizeof(passmime)-1,ftpininame);
	if (strlen(passmime)==0) {
		SetDlgItemText(hWnd,IDC_RESULT,"Could not find connection name!");
		return;
	}

	passmime[0]=0;
	GetPrivateProfileString(connname,"password","",passmime,sizeof(passmime)-1,ftpininame);
	if (strlen(passmime)<=2 || passmime[0]!='!' || passmime[1]!='2') {
		SetDlgItemText(hWnd,IDC_RESULT,"Could not find an encrypted password for this connection!");
		return;
	}
	
	len=MimeDecode(passmime+2,passbuf);
	if (len>saltsize) {
		memcpy(&salt,&passbuf,saltsize);
		memcpy(&decryptbuf,&passbuf[saltsize],len-saltsize);

		int err=DecryptPassword(masterpass,salt,decryptbuf,len-saltsize);
		if (err==0) {
			decryptbuf[sizeof(decryptbuf)-1]=0;
			len=strlen(decryptbuf)+1;
			SetDlgItemText(hWnd,IDC_RESULT,decryptbuf);
		} else if (err==1) {
			SetDlgItemText(hWnd,IDC_RESULT,"CRC error in password, master password must be wrong!");
		} else
			SetDlgItemText(hWnd,IDC_RESULT,"DecryptPassword failed!");
	} else
		SetDlgItemText(hWnd,IDC_RESULT,"Invalid password string!");
}

void ReEncryptFunction(HWND hWnd)
{
	char ftpininame[MAX_PATH],masterpass[MAX_PATH],pass[MAX_PATH],
		 passmime[MAX_PATH], salt[saltsize];
	unsigned char passbuf[MAX_PATH];
	WCHAR masterpassW[MAX_PATH];
	int len;

	GetDlgItemText(hWnd,IDC_ININAME,ftpininame,sizeof(ftpininame)-1);
	GetDlgItemText(hWnd,IDC_MASTERPASS,masterpass,sizeof(masterpass)-1);

	// The password is in UTF-8
	MultiByteToWideChar(CP_ACP,0,masterpass,-1,masterpassW,MAX_PATH);
	WCHAR* srcstart=masterpassW;
	unsigned char* trgstart=(unsigned char*)masterpass;
	ConvertUTF16toUTF8(&srcstart,srcstart+wcslen(srcstart)+2,
		&trgstart,trgstart+sizeof(masterpass)-1);

	GetDlgItemText(hWnd,IDC_RESULT,pass,sizeof(pass)-1);
	
	if (!GenerateRandomByteBlock(salt,saltsize)) {
		SetDlgItemText(hWnd,IDC_RESULT2,"Could not generate random SALT value!");
		return;
	}
	len=EncryptPassword(masterpass,salt,pass,strlen(pass)+1,sizeof(pass)-1);
	if (len>0) {  // Encode as Base64!
		memcpy(&passbuf,&salt,saltsize);
		memcpy(&passbuf[saltsize],&pass,len);
		MimeEncode((char*)passbuf,len+saltsize,passmime+2,sizeof(passmime)-3);
		passmime[0]='!';
		passmime[1]='2';
		SetDlgItemText(hWnd,IDC_RESULT2,passmime);
	} else
		SetDlgItemText(hWnd,IDC_RESULT2,"Invalid password string!");
}

#if defined(__cplusplus)
}
#endif

