#if defined(__cplusplus)
extern "C"
{
#endif

#include <windows.h>
#include <stdlib.h>

char* strlcpy(char* p,const char* p2,int maxlen)
{
	if ((int)strlen(p2)>=maxlen) {
		strncpy(p,p2,maxlen);
		p[maxlen]=0;
	} else
		strcpy(p,p2);
	return p;
}

//strlcat is different from strncat:
//strncat wants maximum number of bytes to copy
//strlcat wants maximum size of target buffer!!!
char* strlcat(char* p,const char* p2,int maxlen)
{
	return strncat(p,p2,maxlen-strlen(p));
}

void AddToOutStr(unsigned char *outstr,int* poutlen,int* poutstate,int b,char* carry)
{
	int len;
	char tempbuf[2];
	tempbuf[1]=0;
	len=*poutlen;
	if (b>=64)
		return;
	switch (*poutstate) {
		case 1:
			*carry=b<<2;
			break;
		case 2:
			b<<=4;
			*carry|=(b>>8);
			outstr[len]=*carry;
			*carry=b&255;
			len++;
			break;
		case 3:
			b<<=6;
			*carry|=(b>>8);
			outstr[len]=*carry;
			*carry=b&255;
			len++;
			break;
		case 4:
	        *carry|=b;
			outstr[len]=*carry;
			len++;
	        *carry=0;
			break;
	}
	(*poutstate)++;
	if (*poutstate==5)
		*poutstate=1;
	*poutlen=len;
}

unsigned char MIMETable[80]=
		{62,                          // '+'
       255,255,255,                   // ',','-','.'
       63,                            // '/'
       52,53,54,55,56,57,58,59,60,61, // '0'..'9'
       255,255,255,64,255,255,255,    // ':',';','<','=','>','?','@'
       0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25, //'A'..'Z'
       255,255,255,255,255,255,       // '[','\',']','^','_','`'
       26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51}; // 'a'..'z'

int MimeDecode(char* inputstr,unsigned char* outputstr)
{
	int i,j,outstate,outlen;
	char carry=0;
	outputstr[0]=0;
	outstate=1;
	outlen=0;
	j=strlen(inputstr);
	for (i=0;i<j;i++)
		if (inputstr[i]>='+' && inputstr[i]<='z')
			AddToOutStr(outputstr,&outlen,&outstate,MIMETable[inputstr[i]-'+'],&carry);
	outputstr[outlen]=0;
	return outlen;
}

char MimeTable[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";


char EncodeMIME(unsigned char ch)
{
	return MimeTable[ch & 0x3F];
}

void EncodeMimeTriple(char* inbuf,int j,char* outbuf)
{
	unsigned char c1,c2,c3,c4;
	outbuf[4]=0;
	c1=(unsigned char)(inbuf[0]) >> 2;
	c2=(((unsigned char)(inbuf[0]) << 4) & 0x30) | (((unsigned char)(inbuf[1]) >> 4) & 0xF);
	c3=(((unsigned char)(inbuf[1]) << 2) & 0x3C) | (((unsigned char)(inbuf[2]) >> 6) & 0x3);
	c4=((unsigned char)(inbuf[2]) & 0x3F);
	outbuf[0]=EncodeMIME(c1);
	outbuf[1]=EncodeMIME(c2);
	if (j>1)
		outbuf[2]=EncodeMIME(c3);
	else
		outbuf[2]='=';          //Last char padding
	if (j>2)
		outbuf[3]=EncodeMIME(c4);
	else
		outbuf[3]='=';
}

void MimeEncode(char* inputstr,int inputlen,char* outputstr,int maxlen)
{
	char bufin[8];
	char buf[8];
    int i,j,readbytes;
	outputstr[0]=0;
	j=inputlen;
	readbytes=j;
	i=0;
	while (i<readbytes) {
		memset(bufin,0,4);
		memcpy(bufin,inputstr+i,min(j,3));
		EncodeMimeTriple(bufin,j,buf);
		strlcat(outputstr,buf,maxlen);
		i+=3;
		j-=3;
	}
}


#if defined(__cplusplus)
}
#endif

